if not pcall(dofile,"./Base.rte/Actors/AI/HumanAI.lua") then
	if not pcall(dofile,"/Applications/Cortex Command b27.app/Contents/Resources/Base.rte/Actors/AI/HumanAI.lua") then
	print("Error finding HumanAI.lua!")
	return
	end
end


HAICreate = Create
HAIUpdate = UpdateAI

function Create(self)

self.prevHealth = self.Health;

self.garbTimer = Timer();

self.charge = 0
self.collect = false

HAICreate(self)

end

function Update(self)

if not self:IsDead() then self.Lifetime = -1 end

--damage, suspicious

if self.Health+33 < self.prevHealth or self.Health < 0 then

self:AddHealth(self.prevHealth-5-self.Health)

end

if self.Health < 41 then
	self:GibThis();
end

--stop spinning, stop iiiit
self.AngularVel = self.AngularVel*0.7;
--health regen

if math.random()<0.03 and self.Health < 100 then self:AddHealth(1) self.charge = self.charge+0.1 end

if self.Health > 99 then self.Health = 100 end

self.prevHealth = self.Health

--i can has claws
if not self:HasObject("Drone Claw") then
	local claw = CreateHDFirearm("Drone Claw");
	self:AddInventoryItem(claw);
end
if not self:HasObject("Drone Claw OffH") then
	local claw = CreateHDFirearm("Drone Claw OffH");
	self:AddInventoryItem(claw);
end

local controller = self:GetController();
if self:HasObjectInGroup("Zombiebot weapons") and self.EquippedItem.PresetName =="Drone Claw" and not self:IsPlayerControlled() then
	controller:SetState(Controller.WEAPON_CHANGE_NEXT,true)
end
if self.charge>100 then self.charge = 100 end

if self.charge > 25 then

	local part
	for i=0,math.random(1,math.floor(self.charge/10)) do
				if 150*math.random()<self.charge then
					part = CreateMOSParticle("Rocket Launcher Smoke 2b");
					part.Pos = self.Pos+Vector(math.random(-14,14),math.random(-20,15));
					part.Vel.Y = math.random(-30,0)/12;
					MovableMan:AddParticle(part);
				end
				if self.charge==100 and math.random()>0.993 then
					part = CreateMOSParticle("Fire Puff Small");
					part.Pos = self.Pos+Vector(math.random(-14,14),math.random(-20,15));
					part.Vel.Y = math.random(-30,0)/12;
					MovableMan:AddParticle(part);
				end
	end


end



for weapon in MovableMan.Items do
	if SceneMan:ShortestDistance(self.Pos,weapon.Pos,true).Magnitude<40 and self.Age>5 then
		if not ( weapon.ClassName == "HDFirearm" and (weapon:HasObjectInGroup("Zombiebot weapons")) ) then

		self.charge = self.charge + (weapon.Mass)^(4/3.5)/1.8
		
		weapon.ToSettle = true

		
		end
	end
end

	if self.ToDelete then
	--print(self.charge)
		if self.charge>100 then self.charge = 100 end

		local part
			if  self.Sharpness < 4 then
					if self.charge == 100 then
					part = CreateMOPixel("Elite Rezzer");
					else
					part = CreateMOPixel("Drone Rezzer");
					end
					part.Pos = self.Pos;
					part.Team = self.Team;
					MovableMan:AddParticle(part);
					part.PinStrength = self.Sharpness+1
						if self.charge>40 then
							local part
							for i=0,2 do

								if math.random()*100<self.charge*0.6 then
						
										part = CreateAEmitter("ZombBot Rez Head");
										part.Pos = self.Pos;
										part.Team = self.Team;
										part.Vel = self.Vel+Vector(math.random(-40,40),math.random(-40,40))
										MovableMan:AddParticle(part);
										ActivityMan:GetActivity():ReportDeath(self.Team,1);

								end
							
							end
						end

			end

	end

   if self.garbTimer:IsPastSimMS(10000) then
      collectgarbage("collect");
      self.garbTimer:Reset();
	  self:CreateGetWeaponBehavior()
   end
 
end
  
function AIUpdate(self)
HAIUpdate(self)

if self:GetController():IsState(Controller.BODY_JUMPSTART) then
	if math.random()>0.85 then 
	self:GetController():SetState(Controller.BODY_CROUCH,true)
	end
end

end

function Gib(self)
self:GibThis()
end