ZombBotBehaviours = {}

function ZombBotBehaviours.DesignatorBehaviour(self)

--self.AIMode = Actor.AIMODE_NONE

print("Designation behaviour started")

self.Designating = true

self.DesignationTargetPlayer=-1
self.DesignatingStartPos = false

--underground?
local str = SceneMan:CastStrengthSumRay(self.Pos,self.Pos-Vector(0,70),5,0)
local mat = SceneMan:GetTerrMatter(SceneMan:GetLastRayHitPos().X,SceneMan:GetLastRayHitPos().Y)
--if we're in a bunker, stop this
if mat == 177 or mat == 179 or mat == 181 or mat == 4 then --concrete, mega metal, door metal, xenocromium

print("inside bunker, aborting designation")
self.Designating = false
return true

end

if str>6 then
--save position, determine a good spot for designating, move there
self.DesignatingStartPos = self.Pos
local target = SceneMan:MovePointToGround(Vector(self.Pos.X,0),30,5)
if target.Y-self.Pos.Y>300 then 
target = SceneMan:MovePointToGround(Vector(self.Pos.X+200,0),30,5)
	if SceneMan:ShortestDistance(self.Pos,target,true).Magnitude>400 then
	target = SceneMan:MovePointToGround(Vector(self.Pos.X-200,0),30,5)
		if SceneMan:ShortestDistance(self.Pos,target,true).Magnitude>400 then print("Aborting designation, too deep") self.Designating = false return true end --too deep, screw it
	end
end

	self.AIMode = Actor.AIMODE_GOTO
	self:ClearAIWaypoints()
	self:AddAISceneWaypoint(target)
	self:CreateGoToBehavior()
	print("Relocating")

end
	print("beep")
	while not ( self.AIMode == Actor.AIMODE_SENTRY or self.AIMode == Actor.AIMODE_GOLDDIG or self.AIMode == Actor.AIMODE_BRAINHUNT  ) do
		coroutine.yield()
	end
	--target the enemy with most funds
	
	print("Determining target player")
	local act = ActivityMan:GetActivity()
	local funds, maxfunds = 0,0

	local team
	
	for player = Activity.PLAYER_1, Activity.MAXPLAYERCOUNT - 1 do
		team = act:GetTeamOfPlayer(player)
		if team==self.Team then self.OwnerPlayer = player else
			funds = act:GetTeamFunds(team)
			if funds>maxfunds then
			maxfunds = funds
			self.DesignationTargetPlayer = player
			end
		end
	end
	print("Targeting player "..self.DesignationTargetPlayer)
	if self.DesignationTargetPlayer == -1 then print("No target player") self.Designating = false return true end

	coroutine.yield()

	
	local brain = act:GetPlayerBrain(self.DesignationTargetPlayer)
	if not MovableMan:ValidMO(brain) then print("No target brain") self.Designating = false return true end
	self.DesignationTarget = Vector(brain.Pos.X,0)
	--can we see the desired point?
	while SceneMan:ShortestDistance(self.ViewPoint,self.DesignationTarget,true).Magnitude>500 do
	--print(SceneMan:ShortestDistance(self.ViewPoint,self.DesignationTarget,true).Magnitude)
	self.DesignationTarget = Vector(brain.Pos.X,0)
	str = SceneMan:CastStrengthSumRay(self.Pos,self.DesignationTarget,10,0)
	if str>0 then
		self.DesignationTarget = Vector(brain.Pos.X+150,0)
		str = SceneMan:CastStrengthSumRay(self.Pos,self.DesignationTarget,10,0)
		if str>0 then
			self.DesignationTarget = Vector(brain.Pos.X-150,0)
			str = SceneMan:CastStrengthSumRay(self.Pos,self.DesignationTarget,10,0)
			if str>0 then 
				if self.DesignatingStartPos then
				self.AIMode = Actor.AIMODE_GOTO
				self:ClearAIWaypoints()
				self:AddAISceneWaypoint(self.DesignatingStartPos)
				self:CreateGoToBehavior()
				end
			print("no line of sight to desired designation point")
			self.Designating = false
			return true end
		end
	end
	--print("choosing designator")
	while self.EquippedItem.PresetName ~= "Drop Designator" do
	self:GetController():SetState(Controller.WEAPON_CHANGE_PREV,true)
	coroutine.yield()
	end
	--print("Starting designation")
	local c
	if self.HFlipped then c = 1 else c = 0 end
	self:SetAimAngle(SceneMan:ShortestDistance(self.Pos,self.DesignationTarget,true).AbsRadAngle+3.14*c)
	self:GetController():SetState(Controller.AIM_SHARP,true)
	print(SceneMan:ShortestDistance(self.Pos,self.DesignationTarget,true).AbsRadAngle)
	print(self:GetAimAngle(false))
	coroutine.yield()
	end

	print("Designating...")
	self:GetController():SetState(Controller.WEAPON_FIRE,true)
	coroutine.yield()
	print("buying")
	act:SetOverridePurchaseList(rte.OffensiveLoadouts[math.ceil(math.random() * #rte.OffensiveLoadouts)], self.OwnerPlayer);
	act:CreateDelivery(self.OwnerPlayer);
	if self.DesignatingStartPos then
	print("Heading back")
	self.AIMode = Actor.AIMODE_GOTO
	self:ClearAIWaypoints()
	self:AddAISceneWaypoint(self.DesignatingStartPos)
	self:CreateGoToBehavior()
	else
	self.AIMode = Actor.AIMODE_SENTRY
	end
self.Designating = false
self:GetController():SetState(Controller.WEAPON_CHANGE_NEXT,true)
print("Done.")
return true
end
