function Create(self)
	local dist;
	local curdist;
	curdist = 30;
	for actor in MovableMan.Actors do

	dist = SceneMan:ShortestDistance(self.Pos-self.Vel*0.2,actor.Pos,SceneMan.SceneWrapsX).Magnitude;
		if actor.PresetName == "ZombieBot Elite" and dist<curdist then
		curdist = dist;
		self.Team = actor.Team
		self.parent = actor;
		end
	end
if not MovableMan:IsActor(self.parent) then
self.Lifetime = 1
return
elseif self.parent.PinStrength == 44567 then self.Lifetime = 1 return end

local MOID
MOID = SceneMan:CastMORay(self.Pos-self.Vel*0.02,self.Vel.Normalized*35,self.parent.ID,self.Team,0,true,1)

	if MOID ~= 255 then

		local MO
		MO = MovableMan:GetMOFromID(MOID)

		if ( MO.ClassName == "ACDropShip" or MO.ClassName == "ACRocket" ) and MO.RootID == MOID and ToActor(MO).Health > 60 and string.find(MO.PresetName,"Hijacked") == nil and MO.Team ~= self.parent.Team then
		--oinks
		self.Hijack = true
		self.Target = ToActor(MO)
		self.Offset = (self.parent.Pos-MO.Pos).Normalized*((SceneMan:GetLastRayHitPos()-MO.Pos).Magnitude*1.1+14)
		self.roll = self.Offset.AbsRadAngle-MO.RotAngle;
		self.flip = MO.HFlipped
		self.parent:SetWhichMOToNotHit(MO,-1);
		self.PinStrength = 20000
		self.oldPresetName = MO.PresetName
		MO.PresetName = "Hijacked "..MO.PresetName
		self.effect = CreateAEmitter("WeldEmitter")
		self.effect.Pos = self.parent.Pos
		self.targetHealth = self.Target:AddHealth(0)
		MovableMan:AddParticle(self.effect)
		else
			--if MO.ClassName ~= "ADoor" then

			--slice and dice
				local part 
				part = CreateMOSRotating("Elite Slice")
				part.Pos = self.Pos+self.Vel*0.06
				part.Vel = self.Vel*2
				part.AngularVel = (math.random()-0.5)*22
				part.RotAngle = self.Vel.AbsRadAngle
				part:SetWhichMOToNotHit(self.parent,-1)
				MovableMan:AddParticle(part)
				
				for i=0,4 do
				part = CreateMOPixel("Particle Slicing")
				part.Pos = self.Pos+self.Vel*0.06+Vector(2,2)*(math.random()-0.5)
				part.Vel = self.Vel*4
				part:SetWhichMOToNotHit(self.parent,-1)
				MovableMan:AddParticle(part)
				end
				--sound
					part = CreateMOSRotating("Jump SFX")
					part.Pos = self.Pos
					MovableMan:AddParticle(part)
					self.Lifetime = 1
			
			--end
		end
	else
	--pew
	local part 
	part = CreateAEmitter("Particle ElitePlasma")
	part.Pos = self.Pos
	part.Vel = self.Vel*1.4
	part.RotAngle = self.Vel.AbsRadAngle
	MovableMan:AddParticle(part)
	--sound
	part = CreateMOSRotating("Plasma SFX")
	part.Pos = self.Pos
	MovableMan:AddParticle(part)
	self.Lifetime = 1
	
	end
end

function Update(self)
local die
if MovableMan:IsActor(self.parent) then
	if self.Hijack then
		if MovableMan:IsActor(self.Target) then
			if (self.Target:AddHealth(0)/self.targetHealth)>0.75 then
			self.ToDelete = false
			
			self.parent.AIMode = Actor.AIMODE_NONE
			self.parent:GetController().Disabled=true
			self.parent:GetController():SetState(Controller.WEAPON_FIRE,false)
			local offset = self.Offset
			
			if self.flip ~= self.Target.HFlipped then
				self.Offset.X = offset.X*-1; self.flip = self.target.HFlipped; end

				self.parent.Pos = Vector(self.Target.Pos.X + (offset.Magnitude * math.cos(self.Target.RotAngle + self.roll)),self.Target.Pos.Y - (offset.Magnitude * math.sin(self.Target.RotAngle + self.roll)))
				self.parent.Vel = self.Target.Vel
				

					local angle = SceneMan:ShortestDistance(self.parent.Pos,self.Target.Pos,true).AbsRadAngle
						if angle > math.pi/2 then self.parent.HFlipped = true
						else self.parent.HFlipped = false end
					self.parent:SetAimAngle(self.parent:FacingAngle(angle));
					
					
					if MovableMan:IsParticle(self.effect) then
					self.effect.ToDelete = false
					self.effect.Pos = (self.parent.EyePos+self.Target.Pos)*0.5
					self.effect.RotAngle = angle
					end

			else
				--hijack
				local part
				part = CreateMOSRotating("Hijack SFX")
				part.Pos = self.Target.Pos
				MovableMan:AddParticle(part)
				self.parent.PinStrength = 44567
				self.parent.Lifetime = 1
				--contents are added up to craft mass
				local craftmass
				if self.Target.ClassName=="ACDropShip" then
				craftmass = CreateACDropShip(self.oldPresetName).Mass
				else
				craftmass = CreateACRocket(self.oldPresetName).Mass
				end
				
				local craftscale = math.ceil(craftmass/600)
				self.Target.RotAngle = self.Target.RotAngle+math.pi*70

				if string.find(self.parent.PresetName,"Skirm") ~= nil then
					for i=0,math.random(craftscale,3*craftscale) do
					part = CreateAEmitter("ZombBot Skirm Rez Head")
					part.Team = self.parent.Team
					self.Target:AddInventoryItem(part)
					ActivityMan:GetActivity():ReportDeath(self.parent.Team,1);	
					end
					for i=0,math.random(2,3*craftscale) do
					part = CreateMOPixel("Skirm Drone Rezzer")
					part.Team = self.parent.Team
					part.Sharpness = 0
					self.Target:AddInventoryItem(part)
					ActivityMan:GetActivity():ReportDeath(self.parent.Team,1);
					end				
				else
					for i=0,math.random(2,craftscale) do
					part = CreateAEmitter("ZombBot Rez Head")
					part.Team = self.parent.Team
					self.Target:AddInventoryItem(part)
					ActivityMan:GetActivity():ReportDeath(self.parent.Team,1);
					end
					for i=0,math.random(2,craftscale) do
					part = CreateMOPixel("Drone Rezzer")
					part.Team = self.parent.Team
					part.Sharpness = 0
					self.Target:AddInventoryItem(part)
					ActivityMan:GetActivity():ReportDeath(self.parent.Team,1);
					end
				end

				--self.Target.Mass = self.Target.Mass*1.33 --bye
				die = true
				--print("over")
			end
		else
		die = true
		self.parent:GetController().Disabled=false
		self.parent.AIMode = Actor.AIMODE_SENTRY
		end
	end

else die = true end

if die then self.Lifetime = 1 self.effect.Lifetime = 1 self.ToDelete = true self.effect.ToDelete = true end

end
